// IEditor.cpp : Implementation of DLL Exports.

// *******************************************************************
// File    : IEditor.cpp 
// Author  : Igor Tolmachev
// Email   : info@itsamples.com
// Web     : www.itsamples.com 
// You are free to use/modify this code but leave this header intact.
// *******************************************************************

// Note: Proxy/Stub Information
//      To build a separate proxy/stub DLL, 
//      run nmake -f IEditorps.mk in the project directory.

#include "stdafx.h"
#include "resource.h"
#include "shlguid.h"
#include <initguid.h>
#include "IEditor.h"

#include "IEditor_i.c"
#include "LBandClass.h"
#include "ToolButton.h"


CComModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
OBJECT_ENTRY(CLSID_LBandClass, CLBandClass)
OBJECT_ENTRY(CLSID_ToolButton, CToolButton)
END_OBJECT_MAP()

/////////////////////////////////////////////////////////////////////////////
// DLL Entry Point

extern "C"
BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID /*lpReserved*/)
{
    if (dwReason == DLL_PROCESS_ATTACH)
    {
        _Module.Init(ObjectMap, hInstance, &LIBID_IEDITORLib);
        DisableThreadLibraryCalls(hInstance);
    }
    else if (dwReason == DLL_PROCESS_DETACH)
        _Module.Term();
    return TRUE;    // ok
}

/////////////////////////////////////////////////////////////////////////////
// Used to determine whether the DLL can be unloaded by OLE

STDAPI DllCanUnloadNow(void)
{
    return (_Module.GetLockCount()==0) ? S_OK : S_FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Returns a class factory to create an object of the requested type

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
    return _Module.GetClassObject(rclsid, riid, ppv);
}

/////////////////////////////////////////////////////////////////////////////
// DllRegisterServer - Adds entries to the system registry

STDAPI DllRegisterServer(void)
{
	_Module.RegisterServer(TRUE);
	// registers the ExplorerBar with the correct category
	// This clears the Internet Explorer Browser Helper Object cache
	// see Q247705 and Q214842 for details
	//::SHDeleteKey(HKEY_CURRENT_USER, "Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Discardable\\PostSetup\\Component Categories\\{00021493-0000-0000-C000-000000000046}\\Enum");
	//::SHDeleteKey(HKEY_CURRENT_USER, "Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Discardable\\PostSetup\\Component Categories\\{00021494-0000-0000-C000-000000000046}\\Enum");
	//::SHDeleteKey(HKEY_CLASSES_ROOT, "Component Categories\\{00021492-0000-0000-C000-000000000046}\\Enum");
	ICatRegister* pcr;

	HRESULT hr = S_OK;

	CoInitialize(NULL);

	hr = CoCreateInstance (CLSID_StdComponentCategoriesMgr, NULL,CLSCTX_INPROC_SERVER,IID_ICatRegister, (LPVOID*) &pcr);

	if(SUCCEEDED(hr))
	{
		hr = pcr->RegisterClassImplCategories(CLSID_LBandClass, 1, &(CATID)CATID_CommBand);
		pcr->Release();
	}

	CoUninitialize();

	return SUCCEEDED(hr);
}

/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - Removes entries from the system registry

STDAPI DllUnregisterServer(void)
{
	_Module.UnregisterServer(TRUE);
	
	ICatRegister* pcr;

	HRESULT hr = S_OK;

	CoInitialize(NULL);

	hr = CoCreateInstance (CLSID_StdComponentCategoriesMgr, NULL,CLSCTX_INPROC_SERVER,IID_ICatRegister, (LPVOID*) &pcr);

	if(SUCCEEDED(hr))
	{
		hr = pcr->UnRegisterClassImplCategories(CLSID_LBandClass, 1, &(CATID)CATID_CommBand);
		pcr->Release();
	}

	CoUninitialize();

	return SUCCEEDED(hr);
}


