// ToolButton.h : Declaration of the CToolButton
// *******************************************************************
// File    : ToolButton.h 
// Author  : Igor Tolmachev
// Email   : info@itsamples.com
// Web     : www.itsamples.com 
// You are free to use/modify this code but leave this header intact.
// *******************************************************************

#ifndef __TOOLBUTTON_H_
#define __TOOLBUTTON_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CToolButton
class ATL_NO_VTABLE CToolButton : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CToolButton, &CLSID_ToolButton>,
	public IDispatchImpl<IToolButton, &IID_IToolButton, &LIBID_IEDITORLib>,
	public IObjectWithSiteImpl<CToolButton>,
	public IOleCommandTarget
{
public:
	CToolButton()
	{
		m_pWebBrowser2 = NULL;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_TOOLBUTTON)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CToolButton)
	COM_INTERFACE_ENTRY(IToolButton)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IObjectWithSite)
	COM_INTERFACE_ENTRY(IOleCommandTarget)
END_COM_MAP()

// IToolButton
public:
	STDMETHOD(QueryStatus)(const GUID* pguidCmdGroup, ULONG cCmds, OLECMD prgCmds[], OLECMDTEXT* pCmdText);
	STDMETHOD(Exec)(const GUID*, DWORD nCmdID, DWORD, VARIANTARG*, VARIANTARG* pvaOut);
	STDMETHOD(SetSite)(IUnknown *pUnkSite);

public:
	CComPtr<IWebBrowser2>     m_pWebBrowser2;

protected:
	BOOL IsBarVisible(HWND hWndBrowser);
	BOOL m_bIsIe7;
};

#endif //__TOOLBUTTON_H_
